//------------------------------------------------------------------
//      FFT NXFŌ̒ȉ𕪗
//          \ FFT NX̎ \
//------------------------------------------------------------------
#include "FFT.hpp"

//------------------------------------------------------------------
//      RXgN^
//------------------------------------------------------------------
FFT::FFT(const int n) :
        nFFT(n), n_abs(std::abs(n)), nInv(fInv(std::abs(n))),
        w_tbl(std::abs(n)/2), b_tbl(std::abs(n)), u(std::abs(n))
{
    assert(n);          // f[^ 0 ̏ꍇɋI
    int pw2 = n_abs;
    while ((pw2 & 0x1) == 0) pw2 = pw2 >> 1;
    assert(pw2 == 0x1); // f[^Qׂ̂ł͂ȂꍇɋI

// ]q̌vZ
    const float arg = -6.28318531f*fInv(nFFT);
    for (int m=0; m<(n_abs >> 1) ;m++)
        w_tbl[m] = Complex(std::cosf(arg*m), std::sinf(arg*m));

// rbgtp
    int n_half = n_abs >> 1;
    b_tbl[0] = 0;
    for (int m=1; m<n_abs; m<<=1)
    {
        for (int k=0; k<m; k++) b_tbl[k+m] = b_tbl[k] + n_half;
        n_half = n_half >> 1;
    }
}

//------------------------------------------------------------------
//      FFT ̎s
//------------------------------------------------------------------
void FFT::Execute(const Complex x[], Complex y[])
{
    Complex utmp;
    int kx, n_half2;
    int n_half = n_abs >> 1;

    for (int n=0; n<n_abs; n++) u[n] = x[n];

// Ō̒i
    for (int stg=1; stg<(n_abs>>1); stg<<=1)
    {
        n_half2 = n_half << 1;
        for (int kp=0; kp<n_abs; kp+=n_half2)
        {
            kx = 0;
            for (int k=kp; k<kp+n_half; k++)
            {
                utmp = u[k+n_half];
                u[k+n_half] = (u[k] - utmp)*w_tbl[kx];  // o^tCZ
                u[k] = u[k] + utmp;                     // o^tCZ
                kx = kx + stg;
            }
        }
        n_half = n_half >> 1;
    }

// Ō̒ȉ
    for (int k=0; k<n_abs; k+=2)
    {
        utmp = u[k+1];
        u[k+1] = u[k] - utmp;
        u[k] = u[k] + utmp;
    }

// rbgt̕בւ
    for (int k=0; k<n_abs; k++) y[k] = u[b_tbl[k]];

// t IFFT ̏ꍇ
    if (nFFT < 0)
        for (int k=0; k<n_abs; k++) y[k] = nInv*y[k];
}
